﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private cv_itens As CustomListView
	Private swipe As CLVSwipe
	Private ProgressBar1 As ActivityIndicator 'must be ActivityIndicator and not B4XView due to a bug in iXUI v1.70 (fixed in iXUI 1.71).
	Private lblPullToRefresh As B4XView
End Sub

Public Sub Initialize
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	B4XPages.GetManager.LogEvents = True
	Root = Root1
	Root.LoadLayout("main")
	
	'https://www.b4x.com/android/forum/threads/b4x-clvswipe-xcustomlistview-swipe-actions-and-pull-to-refresh.98252/
	
	swipe.Initialize(cv_itens, Me, "Swipe")
	swipe.ActionColors = CreateMap("Delete": xui.Color_Red, "Do Something Else": xui.Color_Green, _
		"Action 1": xui.Color_Red, "Action 2": xui.Color_Blue, "Action 3": xui.Color_Yellow)
	Dim PullToRefreshPanel As B4XView = xui.CreatePanel("")
	PullToRefreshPanel.SetLayoutAnimated(0, 0, 0, 100%x, 70dip)
	PullToRefreshPanel.LoadLayout("PullToRefresh")
	swipe.PullToRefreshPanel = PullToRefreshPanel
	cv_itens.DefaultTextColor = xui.Color_Black
	cv_itens.DefaultTextBackgroundColor = xui.Color_White
	CreateItems
End Sub

Private Sub B4XPage_Resize (Width As Int, Height As Int)
	swipe.Resize(Width, Height)
End Sub


Sub cv_itens_ItemClick (Index As Int, Value As Object)
	swipe.CloseLastSwiped
End Sub

Sub cv_itens_ScrollChanged (Offset As Int)
	swipe.ScrollChanged(Offset)
	swipe.CloseLastSwiped
End Sub

Sub Swipe_ActionClicked (Index As Int, ActionText As String)
	Log($"Action clicked: ${Index}, ${ActionText}"$)
	If ActionText = "Delete" Then
		cv_itens.RemoveAt(Index)
	Else If ActionText = "Do Something Else" Then
		Dim p As B4XView = cv_itens.GetPanel(Index)
		Dim lbl As B4XView = p.GetView(0)
		lbl.Text = "Done!!!"
	End If
End Sub

Sub Swipe_RefreshRequested
	lblPullToRefresh.Text = "Loading..."
	ProgressBar1.Visible = True
	ProgressBar1.Visible = False
	ProgressBar1.Visible = True
	'example!!!
	Sleep(3000)
	cv_itens.Clear
	CreateItems
	
	swipe.RefreshCompleted '<-- call to exit refresh mode
	lblPullToRefresh.Text = "Pull to refresh"
	ProgressBar1.Visible = False
End Sub

Sub CreateItems
	Dim cs As CSBuilder
	For i = 1 To 100
		cs.Initialize.Color(Rnd(0xff000000, -1))
		If i Mod 3 = 0 Then
			cs.Append($"Important item ${i} ..."$).PopAll
			cv_itens.AddTextItem(cs, swipe.CreateItemValue("", Array("Delete", "Do Something Else")))
		Else If i Mod 3 = 1 Then
			cs.Append($"Very important item ${i} ..."$).PopAll
			cv_itens.AddTextItem(cs, swipe.CreateItemValue("", Array("Action 1", "Action 2", "Action 3")))
		Else
			cs.Append($"Nothing to see here ${i}"$).PopAll
			cv_itens.AddTextItem(cs, Null)
		End If
	Next
End Sub
